> ## Documentation Index
> Fetch the complete documentation index at: https://docs.pinkfish.ai/llms.txt
> Use this file to discover all available pages before exploring further.

# commercetools-customers

> commercetools Customers - manage customers, customer groups, business units, and associate roles

**Server path:** `/commercetools-customers` | **Type:** Application | **PCID required:** Yes

## Tools

| Tool                                                                                                                                                                                        | Description                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  |
| ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------ |
| [`commercetools_customers_create_associate_roles`](#commercetools_customers_create_associate_roles)                                                                                         | Creating a Associate Role generates the AssociateRoleCreated Message.                                                                                                                                                                                                                                                                                                                                                                                                                                        |
| [`commercetools_customers_create_business_units`](#commercetools_customers_create_business_units)                                                                                           | POST /business-units                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         |
| [`commercetools_customers_create_business_units_search`](#commercetools_customers_create_business_units_search)                                                                             | If the initial indexing is in progress or the feature is inactive, A SearchNotReady error is returned. If inactive, you can reactivate it.                                                                                                                                                                                                                                                                                                                                                                   |
| [`commercetools_customers_create_customer_groups`](#commercetools_customers_create_customer_groups)                                                                                         | POST /customer-groups                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        |
| [`commercetools_customers_create_customers`](#commercetools_customers_create_customers)                                                                                                     | Allows converting an anonymous Cart to the active Cart of a Customer with cart merge.  Creating a Customer produces the CustomerCreated Message. Simultaneously creating two Customers with the same email address can return a LockedField error.                                                                                                                                                                                                                                                           |
| [`commercetools_customers_create_customers_email_confirm`](#commercetools_customers_create_customers_email_confirm)                                                                         | Use this method to verify a global Customer's email during their email verification process.  Verifying the email of the Customer produces the CustomerEmailVerified Message.  After the email is verified, all email tokens issued previously through the email verification flow are invalidated. This invalidation of tokens is eventually consistent.                                                                                                                                                    |
| [`commercetools_customers_create_customers_email_token`](#commercetools_customers_create_customers_email_token)                                                                             | Use this method to create an email token for a global Customer during their email verification process.  Creating an email token for the Customer produces the CustomerEmailTokenCreated Message. The Message will include the token's value, if the token's validity is 60 minutes or less.                                                                                                                                                                                                                 |
| [`commercetools_customers_create_customers_password`](#commercetools_customers_create_customers_password)                                                                                   | Changing the password produces the CustomerPasswordUpdated Message with `reset=false`.                                                                                                                                                                                                                                                                                                                                                                                                                       |
| [`commercetools_customers_create_customers_password_reset`](#commercetools_customers_create_customers_password_reset)                                                                       | Use this method to reset a global Customer's password during their password reset process.  Resetting the password of the Customer produces the CustomerPasswordUpdated Message with `reset=true`.  After the password is reset, all password tokens issued previously through the password reset flow are invalidated. In addition, any access and refresh tokens issued previously through the password flow and refresh token flow are invalidated. This invalidation of tokens is eventually consistent. |
| [`commercetools_customers_create_customers_password_token`](#commercetools_customers_create_customers_password_token)                                                                       | Use this method to create a password reset token for a global Customer during their password reset process.  Creating a password reset token for the Customer produces the CustomerPasswordTokenCreated Message. The Message will include the token's value, if the token's validity is 60 minutes or less.                                                                                                                                                                                                  |
| [`commercetools_customers_create_customers_search`](#commercetools_customers_create_customers_search)                                                                                       | If the initial indexing is in progress or the feature is inactive, a SearchNotReady error is returned. If inactive, you can reactivate it.                                                                                                                                                                                                                                                                                                                                                                   |
| [`commercetools_customers_delete_associate_roles_by_id`](#commercetools_customers_delete_associate_roles_by_id)                                                                             | DELETE /associate-roles/\{ID}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                |
| [`commercetools_customers_delete_associate_roles_by_key`](#commercetools_customers_delete_associate_roles_by_key)                                                                           | Deleting an AssociateRole generates the AssociateRoleDeleted Message. An AssociateRole can only be deleted if it is not assigned to any Associates.                                                                                                                                                                                                                                                                                                                                                          |
| [`commercetools_customers_delete_business_units_by_id`](#commercetools_customers_delete_business_units_by_id)                                                                               | DELETE /business-units/\{ID}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 |
| [`commercetools_customers_delete_business_units_by_key`](#commercetools_customers_delete_business_units_by_key)                                                                             | DELETE /business-units/key=\{key}                                                                                                                                                                                                                                                                                                                                                                                                                                                                            |
| [`commercetools_customers_delete_by_id`](#commercetools_customers_delete_by_id)                                                                                                             | Deleting a Customer produces the CustomerDeleted Message.                                                                                                                                                                                                                                                                                                                                                                                                                                                    |
| [`commercetools_customers_delete_by_key`](#commercetools_customers_delete_by_key)                                                                                                           | Deleting a Customer produces the CustomerDeleted Message.                                                                                                                                                                                                                                                                                                                                                                                                                                                    |
| [`commercetools_customers_delete_customer_groups_by_id`](#commercetools_customers_delete_customer_groups_by_id)                                                                             | DELETE /customer-groups/\{ID}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                |
| [`commercetools_customers_delete_customer_groups_by_key`](#commercetools_customers_delete_customer_groups_by_key)                                                                           | DELETE /customer-groups/key=\{key}                                                                                                                                                                                                                                                                                                                                                                                                                                                                           |
| [`commercetools_customers_get_associate_roles_by_id`](#commercetools_customers_get_associate_roles_by_id)                                                                                   | GET /associate-roles/\{ID}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   |
| [`commercetools_customers_get_associate_roles_by_key`](#commercetools_customers_get_associate_roles_by_key)                                                                                 | GET /associate-roles/key=\{key}                                                                                                                                                                                                                                                                                                                                                                                                                                                                              |
| [`commercetools_customers_get_business_units_associates_by_business_unit_id_and_associate_id`](#commercetools_customers_get_business_units_associates_by_business_unit_id_and_associate_id) | Retrieves roles and permissions of an Associate in a Business Unit.                                                                                                                                                                                                                                                                                                                                                                                                                                          |
| [`commercetools_customers_get_business_units_associates_by_key_and_associate_id`](#commercetools_customers_get_business_units_associates_by_key_and_associate_id)                           | Retrieves roles and permissions of an Associate in a Business Unit.                                                                                                                                                                                                                                                                                                                                                                                                                                          |
| [`commercetools_customers_get_business_units_by_id`](#commercetools_customers_get_business_units_by_id)                                                                                     | GET /business-units/\{ID}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    |
| [`commercetools_customers_get_business_units_by_key`](#commercetools_customers_get_business_units_by_key)                                                                                   | GET /business-units/key=\{key}                                                                                                                                                                                                                                                                                                                                                                                                                                                                               |
| [`commercetools_customers_get_by_id`](#commercetools_customers_get_by_id)                                                                                                                   | GET /customers/\{ID}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         |
| [`commercetools_customers_get_by_key`](#commercetools_customers_get_by_key)                                                                                                                 | GET /customers/key=\{key}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    |
| [`commercetools_customers_get_customer_groups_by_id`](#commercetools_customers_get_customer_groups_by_id)                                                                                   | GET /customer-groups/\{ID}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   |
| [`commercetools_customers_get_customer_groups_by_key`](#commercetools_customers_get_customer_groups_by_key)                                                                                 | GET /customer-groups/key=\{key}                                                                                                                                                                                                                                                                                                                                                                                                                                                                              |
| [`commercetools_customers_list_associate_roles`](#commercetools_customers_list_associate_roles)                                                                                             | GET /associate-roles                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         |
| [`commercetools_customers_list_business_units`](#commercetools_customers_list_business_units)                                                                                               | GET /business-units                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          |
| [`commercetools_customers_list_business_units_search_indexing_status`](#commercetools_customers_list_business_units_search_indexing_status)                                                 | Returns the indexing status of the Business Unit Search for a Project.                                                                                                                                                                                                                                                                                                                                                                                                                                       |
| [`commercetools_customers_list_customer_groups`](#commercetools_customers_list_customer_groups)                                                                                             | GET /customer-groups                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         |
| [`commercetools_customers_list_customers`](#commercetools_customers_list_customers)                                                                                                         | GET /customers                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               |
| [`commercetools_customers_list_customers_email_token_email_token`](#commercetools_customers_list_customers_email_token_email_token)                                                         | Use this method to retrieve a global Customer's details by using the email token during their email verification process.                                                                                                                                                                                                                                                                                                                                                                                    |
| [`commercetools_customers_list_customers_password_token_password_token`](#commercetools_customers_list_customers_password_token_password_token)                                             | Use this method to retrieve the details of a global Customer by using the password token during their password reset process.                                                                                                                                                                                                                                                                                                                                                                                |
| [`commercetools_customers_list_customers_search_indexing_status`](#commercetools_customers_list_customers_search_indexing_status)                                                           | Returns the indexing status of the Customer Search for a Project.                                                                                                                                                                                                                                                                                                                                                                                                                                            |
| [`commercetools_customers_update_associate_roles_by_id`](#commercetools_customers_update_associate_roles_by_id)                                                                             | POST /associate-roles/\{ID}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  |
| [`commercetools_customers_update_associate_roles_by_key`](#commercetools_customers_update_associate_roles_by_key)                                                                           | POST /associate-roles/key=\{key}                                                                                                                                                                                                                                                                                                                                                                                                                                                                             |
| [`commercetools_customers_update_business_units_by_id`](#commercetools_customers_update_business_units_by_id)                                                                               | POST /business-units/\{ID}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   |
| [`commercetools_customers_update_business_units_by_key`](#commercetools_customers_update_business_units_by_key)                                                                             | POST /business-units/key=\{key}                                                                                                                                                                                                                                                                                                                                                                                                                                                                              |
| [`commercetools_customers_update_customer_groups_by_id`](#commercetools_customers_update_customer_groups_by_id)                                                                             | POST /customer-groups/\{ID}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  |
| [`commercetools_customers_update_customer_groups_by_key`](#commercetools_customers_update_customer_groups_by_key)                                                                           | POST /customer-groups/key=\{key}                                                                                                                                                                                                                                                                                                                                                                                                                                                                             |
| [`commercetools_customers_update_customers_by_id`](#commercetools_customers_update_customers_by_id)                                                                                         | Simultaneously updating two Customers with the same email address can return a LockedField error.                                                                                                                                                                                                                                                                                                                                                                                                            |
| [`commercetools_customers_update_customers_by_key`](#commercetools_customers_update_customers_by_key)                                                                                       | Simultaneously updating two Customers with the same email address can return a LockedField error.                                                                                                                                                                                                                                                                                                                                                                                                            |

***

## commercetools\_customers\_create\_associate\_roles

Creating a Associate Role generates the AssociateRoleCreated Message.

**Parameters:**

| Parameter         | Type      | Required | Default | Description                        |
| ----------------- | --------- | -------- | ------- | ---------------------------------- |
| `expand`          | string\[] | No       | —       | Related resources to expand inline |
| `buyerAssignable` | boolean   | No       | —       | Buyer Assignable                   |
| `custom`          | object    | No       | —       | The custom value                   |
| `key`             | string    | Yes      | —       | The key value                      |
| `name`            | string    | No       | —       | The name value                     |
| `permissions`     | string\[] | No       | —       | The permissions value              |

<Expandable title="inputSchema">
  ```json theme={null}
  {
    "type": "object",
    "properties": {
      "PCID": {
        "type": "string",
        "description": "Pink Connect ID for the authenticated connection"
      },
      "expand": {
        "type": "array",
        "items": {
          "type": "string"
        },
        "description": "Related resources to expand inline"
      },
      "buyerAssignable": {
        "type": "boolean",
        "description": "Buyer Assignable"
      },
      "custom": {
        "type": "object",
        "description": "The custom value",
        "properties": {
          "type": {
            "description": "The type value"
          },
          "fields": {
            "type": "object",
            "description": "The fields value"
          }
        },
        "required": [
          "type"
        ]
      },
      "key": {
        "type": "string",
        "description": "The key value"
      },
      "name": {
        "type": "string",
        "description": "The name value"
      },
      "permissions": {
        "type": "array",
        "items": {
          "type": "string",
          "enum": [
            "AddChildUnits",
            "UpdateAssociates",
            "UpdateBusinessUnitDetails",
            "UpdateParentUnit",
            "ViewMyCarts",
            "ViewOthersCarts",
            "UpdateMyCarts",
            "UpdateOthersCarts",
            "CreateMyCarts",
            "CreateOthersCarts",
            "DeleteMyCarts",
            "DeleteOthersCarts",
            "ViewMyOrders",
            "ViewOthersOrders",
            "UpdateMyOrders",
            "UpdateOthersOrders",
            "CreateMyOrdersFromMyCarts",
            "CreateMyOrdersFromMyQuotes",
            "CreateOrdersFromOthersCarts",
            "CreateOrdersFromOthersQuotes",
            "ViewMyQuotes",
            "ViewOthersQuotes",
            "AcceptMyQuotes",
            "AcceptOthersQuotes",
            "DeclineMyQuotes",
            "DeclineOthersQuotes",
            "RenegotiateMyQuotes",
            "RenegotiateOthersQuotes",
            "ReassignMyQuotes",
            "ReassignOthersQuotes",
            "ViewMyQuoteRequests",
            "ViewOthersQuoteRequests",
            "UpdateMyQuoteRequests",
            "UpdateOthersQuoteRequests",
            "CreateMyQuoteRequestsFromMyCarts",
            "CreateQuoteRequestsFromOthersCarts",
            "CreateApprovalRules",
            "UpdateApprovalRules",
            "UpdateApprovalFlows",
            "ViewMyShoppingLists",
            "ViewOthersShoppingLists",
            "UpdateMyShoppingLists",
            "UpdateOthersShoppingLists",
            "CreateMyShoppingLists",
            "CreateOthersShoppingLists",
            "DeleteMyShoppingLists",
            "DeleteOthersShoppingLists"
          ]
        },
        "description": "The permissions value"
      }
    },
    "required": [
      "PCID",
      "key"
    ]
  }
  ```
</Expandable>

***

## commercetools\_customers\_create\_business\_units

POST /business-units

**Parameters:**

| Parameter                  | Type       | Required | Default | Description                        |
| -------------------------- | ---------- | -------- | ------- | ---------------------------------- |
| `expand`                   | string\[]  | No       | —       | Related resources to expand inline |
| `addresses`                | object\[]  | No       | —       | The addresses value                |
| `approvalRuleMode`         | string     | No       | —       | Approval Rule Mode                 |
| `associateMode`            | string     | No       | —       | Associate Mode                     |
| `associates`               | object\[]  | No       | —       | The associates value               |
| `billingAddresses`         | integer\[] | No       | —       | Billing Addresses                  |
| `contactEmail`             | string     | No       | —       | Contact Email                      |
| `custom`                   | object     | No       | —       | The custom value                   |
| `customerGroupAssignments` | object\[]  | No       | —       | Customer Group Assignments         |
| `defaultBillingAddress`    | integer    | No       | —       | Default Billing Address            |
| `defaultShippingAddress`   | integer    | No       | —       | Default Shipping Address           |
| `key`                      | string     | Yes      | —       | The key value                      |
| `name`                     | string     | Yes      | —       | The name value                     |
| `shippingAddresses`        | integer\[] | No       | —       | Shipping Addresses                 |
| `status`                   | string     | No       | —       | The status value                   |
| `storeMode`                | string     | No       | —       | Store Mode                         |
| `stores`                   | any\[]     | No       | —       | The stores value                   |
| `unitType`                 | string     | Yes      | —       | Unit Type                          |

<Expandable title="inputSchema">
  ```json theme={null}
  {
    "type": "object",
    "properties": {
      "PCID": {
        "type": "string",
        "description": "Pink Connect ID for the authenticated connection"
      },
      "expand": {
        "type": "array",
        "items": {
          "type": "string"
        },
        "description": "Related resources to expand inline"
      },
      "addresses": {
        "type": "array",
        "items": {
          "type": "object",
          "properties": {
            "id": {
              "type": "string",
              "description": "The id value"
            },
            "key": {
              "type": "string",
              "description": "The key value"
            },
            "country": {
              "type": "string",
              "description": "The country value"
            },
            "title": {
              "type": "string",
              "description": "The title value"
            },
            "salutation": {
              "type": "string",
              "description": "The salutation value"
            },
            "firstName": {
              "type": "string",
              "description": "First Name"
            },
            "lastName": {
              "type": "string",
              "description": "Last Name"
            },
            "streetName": {
              "type": "string",
              "description": "Street Name"
            },
            "streetNumber": {
              "type": "string",
              "description": "Street Number"
            },
            "additionalStreetInfo": {
              "type": "string",
              "description": "Additional Street Info"
            },
            "postalCode": {
              "type": "string",
              "description": "Postal Code"
            },
            "city": {
              "type": "string",
              "description": "The city value"
            },
            "region": {
              "type": "string",
              "description": "The region value"
            },
            "state": {
              "type": "string",
              "description": "The state value"
            },
            "company": {
              "type": "string",
              "description": "The company value"
            },
            "department": {
              "type": "string",
              "description": "The department value"
            },
            "building": {
              "type": "string",
              "description": "The building value"
            },
            "apartment": {
              "type": "string",
              "description": "The apartment value"
            },
            "pOBox": {
              "type": "string",
              "description": "P O Box"
            },
            "phone": {
              "type": "string",
              "description": "The phone value"
            },
            "mobile": {
              "type": "string",
              "description": "The mobile value"
            },
            "email": {
              "type": "string",
              "description": "The email value"
            },
            "fax": {
              "type": "string",
              "description": "The fax value"
            },
            "additionalAddressInfo": {
              "type": "string",
              "description": "Additional Address Info"
            },
            "externalId": {
              "type": "string",
              "description": "External Id"
            }
          },
          "required": [
            "country"
          ]
        },
        "description": "The addresses value"
      },
      "approvalRuleMode": {
        "type": "string",
        "description": "Approval Rule Mode",
        "enum": [
          "Explicit",
          "ExplicitAndFromParent"
        ]
      },
      "associateMode": {
        "type": "string",
        "description": "Associate Mode",
        "enum": [
          "Explicit",
          "ExplicitAndFromParent"
        ]
      },
      "associates": {
        "type": "array",
        "items": {
          "type": "object",
          "properties": {
            "associateRoleAssignments": {
              "type": "array",
              "items": {
                "type": "object",
                "properties": {
                  "associateRole": {},
                  "inheritance": {
                    "type": "string"
                  }
                }
              },
              "description": "Associate Role Assignments"
            },
            "roles": {
              "type": "array",
              "items": {
                "type": "string"
              },
              "description": "The roles value"
            },
            "customer": {
              "description": "The customer value"
            }
          },
          "required": [
            "associateRoleAssignments",
            "customer"
          ]
        },
        "description": "The associates value"
      },
      "billingAddresses": {
        "type": "array",
        "items": {
          "type": "integer",
          "format": "int32"
        },
        "description": "Billing Addresses"
      },
      "contactEmail": {
        "type": "string",
        "description": "Contact Email"
      },
      "custom": {
        "type": "object",
        "description": "The custom value",
        "properties": {
          "type": {
            "description": "The type value"
          },
          "fields": {
            "type": "object",
            "description": "The fields value"
          }
        },
        "required": [
          "type"
        ]
      },
      "customerGroupAssignments": {
        "type": "array",
        "items": {
          "type": "object",
          "properties": {
            "customerGroup": {
              "description": "Customer Group"
            }
          },
          "required": [
            "customerGroup"
          ]
        },
        "description": "Customer Group Assignments"
      },
      "defaultBillingAddress": {
        "type": "integer",
        "description": "Default Billing Address"
      },
      "defaultShippingAddress": {
        "type": "integer",
        "description": "Default Shipping Address"
      },
      "key": {
        "type": "string",
        "description": "The key value"
      },
      "name": {
        "type": "string",
        "description": "The name value"
      },
      "shippingAddresses": {
        "type": "array",
        "items": {
          "type": "integer",
          "format": "int32"
        },
        "description": "Shipping Addresses"
      },
      "status": {
        "type": "string",
        "description": "The status value",
        "enum": [
          "Active",
          "Inactive"
        ]
      },
      "storeMode": {
        "type": "string",
        "description": "Store Mode",
        "enum": [
          "Explicit",
          "FromParent"
        ]
      },
      "stores": {
        "type": "array",
        "description": "The stores value"
      },
      "unitType": {
        "type": "string",
        "description": "Unit Type",
        "enum": [
          "Company",
          "Division"
        ]
      }
    },
    "required": [
      "PCID",
      "key",
      "name",
      "unitType"
    ]
  }
  ```
</Expandable>

***

## commercetools\_customers\_create\_business\_units\_search

If the initial indexing is in progress or the feature is inactive, A SearchNotReady error is returned. If inactive, you can reactivate it.

**Parameters:**

| Parameter | Type      | Required | Default | Description                         |
| --------- | --------- | -------- | ------- | ----------------------------------- |
| `limit`   | integer   | No       | —       | Maximum number of results to return |
| `offset`  | integer   | No       | —       | The offset value                    |
| `query`   | object    | No       | —       | Search query string                 |
| `sort`    | object\[] | No       | —       | Sort order for results              |

<Expandable title="inputSchema">
  ```json theme={null}
  {
    "type": "object",
    "properties": {
      "PCID": {
        "type": "string",
        "description": "Pink Connect ID for the authenticated connection"
      },
      "limit": {
        "type": "integer",
        "description": "Maximum number of results to return"
      },
      "offset": {
        "type": "integer",
        "description": "The offset value"
      },
      "query": {
        "type": "object",
        "description": "Search query string"
      },
      "sort": {
        "type": "array",
        "items": {
          "type": "object",
          "properties": {
            "field": {
              "type": "string",
              "description": "The field value"
            },
            "language": {
              "type": "string",
              "description": "The language value"
            },
            "order": {
              "type": "string",
              "enum": [
                "asc",
                "desc"
              ],
              "description": "The order value"
            },
            "mode": {
              "type": "string",
              "enum": [
                "min",
                "max",
                "avg",
                "sum"
              ],
              "description": "The mode value"
            },
            "fieldType": {
              "type": "string",
              "enum": [
                "boolean",
                "text",
                "ltext",
                "enum",
                "lenum",
                "number",
                "money",
                "date",
                "datetime",
                "time",
                "reference",
                "set_boolean",
                "set_text",
                "set_ltext",
                "set_enum",
                "set_lenum",
                "set_number",
                "set_money",
                "set_date",
                "set_datetime",
                "set_time",
                "set_reference"
              ],
              "description": "Field Type"
            },
            "filter": {
              "type": "object",
              "description": "The filter value"
            }
          },
          "required": [
            "field",
            "order"
          ]
        },
        "description": "Sort order for results"
      }
    },
    "required": [
      "PCID"
    ]
  }
  ```
</Expandable>

***

## commercetools\_customers\_create\_customer\_groups

POST /customer-groups

**Parameters:**

| Parameter   | Type      | Required | Default | Description                        |
| ----------- | --------- | -------- | ------- | ---------------------------------- |
| `expand`    | string\[] | No       | —       | Related resources to expand inline |
| `custom`    | object    | No       | —       | The custom value                   |
| `groupName` | string    | Yes      | —       | Group Name                         |
| `key`       | string    | No       | —       | The key value                      |

<Expandable title="inputSchema">
  ```json theme={null}
  {
    "type": "object",
    "properties": {
      "PCID": {
        "type": "string",
        "description": "Pink Connect ID for the authenticated connection"
      },
      "expand": {
        "type": "array",
        "items": {
          "type": "string"
        },
        "description": "Related resources to expand inline"
      },
      "custom": {
        "type": "object",
        "description": "The custom value",
        "properties": {
          "type": {
            "description": "The type value"
          },
          "fields": {
            "type": "object",
            "description": "The fields value"
          }
        },
        "required": [
          "type"
        ]
      },
      "groupName": {
        "type": "string",
        "description": "Group Name"
      },
      "key": {
        "type": "string",
        "description": "The key value"
      }
    },
    "required": [
      "PCID",
      "groupName"
    ]
  }
  ```
</Expandable>

***

## commercetools\_customers\_create\_customers

Allows converting an anonymous Cart to the active Cart of a Customer with cart merge.  Creating a Customer produces the CustomerCreated Message. Simultaneously creating two Customers with the same email address can return a LockedField error.

**Parameters:**

| Parameter                  | Type       | Required | Default | Description                        |
| -------------------------- | ---------- | -------- | ------- | ---------------------------------- |
| `expand`                   | string\[]  | No       | —       | Related resources to expand inline |
| `addresses`                | object\[]  | No       | —       | The addresses value                |
| `anonymousCart`            | object     | No       | —       | Anonymous Cart                     |
| `anonymousCartId`          | string     | No       | —       | Anonymous Cart Id                  |
| `anonymousId`              | string     | No       | —       | Anonymous Id                       |
| `authenticationMode`       | string     | No       | —       | Authentication Mode                |
| `billingAddresses`         | integer\[] | No       | —       | Billing Addresses                  |
| `companyName`              | string     | No       | —       | Company Name                       |
| `custom`                   | object     | No       | —       | The custom value                   |
| `customerGroup`            | object     | No       | —       | Customer Group                     |
| `customerGroupAssignments` | object\[]  | No       | —       | Customer Group Assignments         |
| `customerNumber`           | string     | No       | —       | Customer Number                    |
| `dateOfBirth`              | string     | No       | —       | Date Of Birth                      |
| `defaultBillingAddress`    | integer    | No       | —       | Default Billing Address            |
| `defaultShippingAddress`   | integer    | No       | —       | Default Shipping Address           |
| `email`                    | string     | Yes      | —       | The email value                    |
| `externalId`               | string     | No       | —       | External Id                        |
| `firstName`                | string     | No       | —       | First Name                         |
| `isEmailVerified`          | boolean    | No       | —       | Is Email Verified                  |
| `key`                      | string     | No       | —       | The key value                      |
| `lastName`                 | string     | No       | —       | Last Name                          |
| `locale`                   | string     | No       | —       | Locale or language code            |
| `middleName`               | string     | No       | —       | Middle Name                        |
| `password`                 | string     | No       | —       | The password value                 |
| `salutation`               | string     | No       | —       | The salutation value               |
| `shippingAddresses`        | integer\[] | No       | —       | Shipping Addresses                 |
| `stores`                   | any\[]     | No       | —       | The stores value                   |
| `title`                    | string     | No       | —       | The title value                    |
| `vatId`                    | string     | No       | —       | Vat Id                             |

<Expandable title="inputSchema">
  ```json theme={null}
  {
    "type": "object",
    "properties": {
      "PCID": {
        "type": "string",
        "description": "Pink Connect ID for the authenticated connection"
      },
      "expand": {
        "type": "array",
        "items": {
          "type": "string"
        },
        "description": "Related resources to expand inline"
      },
      "addresses": {
        "type": "array",
        "items": {
          "type": "object",
          "properties": {
            "id": {
              "type": "string",
              "description": "The id value"
            },
            "key": {
              "type": "string",
              "description": "The key value"
            },
            "country": {
              "type": "string",
              "description": "The country value"
            },
            "title": {
              "type": "string",
              "description": "The title value"
            },
            "salutation": {
              "type": "string",
              "description": "The salutation value"
            },
            "firstName": {
              "type": "string",
              "description": "First Name"
            },
            "lastName": {
              "type": "string",
              "description": "Last Name"
            },
            "streetName": {
              "type": "string",
              "description": "Street Name"
            },
            "streetNumber": {
              "type": "string",
              "description": "Street Number"
            },
            "additionalStreetInfo": {
              "type": "string",
              "description": "Additional Street Info"
            },
            "postalCode": {
              "type": "string",
              "description": "Postal Code"
            },
            "city": {
              "type": "string",
              "description": "The city value"
            },
            "region": {
              "type": "string",
              "description": "The region value"
            },
            "state": {
              "type": "string",
              "description": "The state value"
            },
            "company": {
              "type": "string",
              "description": "The company value"
            },
            "department": {
              "type": "string",
              "description": "The department value"
            },
            "building": {
              "type": "string",
              "description": "The building value"
            },
            "apartment": {
              "type": "string",
              "description": "The apartment value"
            },
            "pOBox": {
              "type": "string",
              "description": "P O Box"
            },
            "phone": {
              "type": "string",
              "description": "The phone value"
            },
            "mobile": {
              "type": "string",
              "description": "The mobile value"
            },
            "email": {
              "type": "string",
              "description": "The email value"
            },
            "fax": {
              "type": "string",
              "description": "The fax value"
            },
            "additionalAddressInfo": {
              "type": "string",
              "description": "Additional Address Info"
            },
            "externalId": {
              "type": "string",
              "description": "External Id"
            }
          },
          "required": [
            "country"
          ]
        },
        "description": "The addresses value"
      },
      "anonymousCart": {
        "description": "Anonymous Cart"
      },
      "anonymousCartId": {
        "type": "string",
        "description": "Anonymous Cart Id"
      },
      "anonymousId": {
        "type": "string",
        "description": "Anonymous Id"
      },
      "authenticationMode": {
        "type": "string",
        "description": "Authentication Mode",
        "enum": [
          "Password",
          "ExternalAuth"
        ]
      },
      "billingAddresses": {
        "type": "array",
        "items": {
          "type": "integer",
          "format": "int32"
        },
        "description": "Billing Addresses"
      },
      "companyName": {
        "type": "string",
        "description": "Company Name"
      },
      "custom": {
        "type": "object",
        "description": "The custom value",
        "properties": {
          "type": {
            "description": "The type value"
          },
          "fields": {
            "type": "object",
            "description": "The fields value"
          }
        },
        "required": [
          "type"
        ]
      },
      "customerGroup": {
        "description": "Customer Group"
      },
      "customerGroupAssignments": {
        "type": "array",
        "items": {
          "type": "object",
          "properties": {
            "customerGroup": {
              "description": "Customer Group"
            }
          },
          "required": [
            "customerGroup"
          ]
        },
        "description": "Customer Group Assignments"
      },
      "customerNumber": {
        "type": "string",
        "description": "Customer Number"
      },
      "dateOfBirth": {
        "type": "string",
        "description": "Date Of Birth"
      },
      "defaultBillingAddress": {
        "type": "integer",
        "description": "Default Billing Address"
      },
      "defaultShippingAddress": {
        "type": "integer",
        "description": "Default Shipping Address"
      },
      "email": {
        "type": "string",
        "description": "The email value"
      },
      "externalId": {
        "type": "string",
        "description": "External Id"
      },
      "firstName": {
        "type": "string",
        "description": "First Name"
      },
      "isEmailVerified": {
        "type": "boolean",
        "description": "Is Email Verified"
      },
      "key": {
        "type": "string",
        "description": "The key value"
      },
      "lastName": {
        "type": "string",
        "description": "Last Name"
      },
      "locale": {
        "type": "string",
        "description": "Locale or language code"
      },
      "middleName": {
        "type": "string",
        "description": "Middle Name"
      },
      "password": {
        "type": "string",
        "description": "The password value"
      },
      "salutation": {
        "type": "string",
        "description": "The salutation value"
      },
      "shippingAddresses": {
        "type": "array",
        "items": {
          "type": "integer",
          "format": "int32"
        },
        "description": "Shipping Addresses"
      },
      "stores": {
        "type": "array",
        "description": "The stores value"
      },
      "title": {
        "type": "string",
        "description": "The title value"
      },
      "vatId": {
        "type": "string",
        "description": "Vat Id"
      }
    },
    "required": [
      "PCID",
      "email"
    ]
  }
  ```
</Expandable>

***

## commercetools\_customers\_create\_customers\_email\_confirm

Use this method to verify a global Customer's email during their email verification process.  Verifying the email of the Customer produces the CustomerEmailVerified Message.  After the email is verified, all email tokens issued previously through the email verification flow are invalidated. This invalidation of tokens is eventually consistent.

**Parameters:**

| Parameter    | Type    | Required | Default | Description       |
| ------------ | ------- | -------- | ------- | ----------------- |
| `tokenValue` | string  | Yes      | —       | Token Value       |
| `version`    | integer | No       | —       | The version value |

<Expandable title="inputSchema">
  ```json theme={null}
  {
    "type": "object",
    "properties": {
      "PCID": {
        "type": "string",
        "description": "Pink Connect ID for the authenticated connection"
      },
      "tokenValue": {
        "type": "string",
        "description": "Token Value"
      },
      "version": {
        "type": "integer",
        "description": "The version value"
      }
    },
    "required": [
      "PCID",
      "tokenValue"
    ]
  }
  ```
</Expandable>

***

## commercetools\_customers\_create\_customers\_email\_token

Use this method to create an email token for a global Customer during their email verification process.  Creating an email token for the Customer produces the CustomerEmailTokenCreated Message. The Message will include the token's value, if the token's validity is 60 minutes or less.

**Parameters:**

| Parameter               | Type    | Required | Default | Description             |
| ----------------------- | ------- | -------- | ------- | ----------------------- |
| `id`                    | string  | Yes      | —       | The id value            |
| `invalidateOlderTokens` | boolean | No       | —       | Invalidate Older Tokens |
| `ttlMinutes`            | integer | Yes      | —       | Ttl Minutes             |
| `version`               | integer | No       | —       | The version value       |

<Expandable title="inputSchema">
  ```json theme={null}
  {
    "type": "object",
    "properties": {
      "PCID": {
        "type": "string",
        "description": "Pink Connect ID for the authenticated connection"
      },
      "id": {
        "type": "string",
        "description": "The id value"
      },
      "invalidateOlderTokens": {
        "type": "boolean",
        "description": "Invalidate Older Tokens"
      },
      "ttlMinutes": {
        "type": "integer",
        "description": "Ttl Minutes"
      },
      "version": {
        "type": "integer",
        "description": "The version value"
      }
    },
    "required": [
      "PCID",
      "id",
      "ttlMinutes"
    ]
  }
  ```
</Expandable>

***

## commercetools\_customers\_create\_customers\_password

Changing the password produces the CustomerPasswordUpdated Message with `reset=false`.

**Parameters:**

| Parameter         | Type    | Required | Default | Description       |
| ----------------- | ------- | -------- | ------- | ----------------- |
| `currentPassword` | string  | Yes      | —       | Current Password  |
| `id`              | string  | Yes      | —       | The id value      |
| `newPassword`     | string  | Yes      | —       | New Password      |
| `version`         | integer | Yes      | —       | The version value |

<Expandable title="inputSchema">
  ```json theme={null}
  {
    "type": "object",
    "properties": {
      "PCID": {
        "type": "string",
        "description": "Pink Connect ID for the authenticated connection"
      },
      "currentPassword": {
        "type": "string",
        "description": "Current Password"
      },
      "id": {
        "type": "string",
        "description": "The id value"
      },
      "newPassword": {
        "type": "string",
        "description": "New Password"
      },
      "version": {
        "type": "integer",
        "description": "The version value"
      }
    },
    "required": [
      "PCID",
      "currentPassword",
      "id",
      "newPassword",
      "version"
    ]
  }
  ```
</Expandable>

***

## commercetools\_customers\_create\_customers\_password\_reset

Use this method to reset a global Customer's password during their password reset process.  Resetting the password of the Customer produces the CustomerPasswordUpdated Message with `reset=true`.  After the password is reset, all password tokens issued previously through the password reset flow are invalidated. In addition, any access and refresh tokens issued previously through the password flow and refresh token flow are invalidated. This invalidation of tokens is eventually consistent.

**Parameters:**

| Parameter     | Type    | Required | Default | Description       |
| ------------- | ------- | -------- | ------- | ----------------- |
| `newPassword` | string  | Yes      | —       | New Password      |
| `tokenValue`  | string  | Yes      | —       | Token Value       |
| `version`     | integer | No       | —       | The version value |

<Expandable title="inputSchema">
  ```json theme={null}
  {
    "type": "object",
    "properties": {
      "PCID": {
        "type": "string",
        "description": "Pink Connect ID for the authenticated connection"
      },
      "newPassword": {
        "type": "string",
        "description": "New Password"
      },
      "tokenValue": {
        "type": "string",
        "description": "Token Value"
      },
      "version": {
        "type": "integer",
        "description": "The version value"
      }
    },
    "required": [
      "PCID",
      "newPassword",
      "tokenValue"
    ]
  }
  ```
</Expandable>

***

## commercetools\_customers\_create\_customers\_password\_token

Use this method to create a password reset token for a global Customer during their password reset process.  Creating a password reset token for the Customer produces the CustomerPasswordTokenCreated Message. The Message will include the token's value, if the token's validity is 60 minutes or less.

**Parameters:**

| Parameter               | Type    | Required | Default | Description             |
| ----------------------- | ------- | -------- | ------- | ----------------------- |
| `email`                 | string  | Yes      | —       | The email value         |
| `invalidateOlderTokens` | boolean | No       | —       | Invalidate Older Tokens |
| `ttlMinutes`            | integer | No       | —       | Ttl Minutes             |

<Expandable title="inputSchema">
  ```json theme={null}
  {
    "type": "object",
    "properties": {
      "PCID": {
        "type": "string",
        "description": "Pink Connect ID for the authenticated connection"
      },
      "email": {
        "type": "string",
        "description": "The email value"
      },
      "invalidateOlderTokens": {
        "type": "boolean",
        "description": "Invalidate Older Tokens"
      },
      "ttlMinutes": {
        "type": "integer",
        "description": "Ttl Minutes"
      }
    },
    "required": [
      "PCID",
      "email"
    ]
  }
  ```
</Expandable>

***

## commercetools\_customers\_create\_customers\_search

If the initial indexing is in progress or the feature is inactive, a SearchNotReady error is returned. If inactive, you can reactivate it.

**Parameters:**

| Parameter | Type      | Required | Default | Description                         |
| --------- | --------- | -------- | ------- | ----------------------------------- |
| `limit`   | integer   | No       | —       | Maximum number of results to return |
| `offset`  | integer   | No       | —       | The offset value                    |
| `query`   | object    | No       | —       | Search query string                 |
| `sort`    | object\[] | No       | —       | Sort order for results              |

<Expandable title="inputSchema">
  ```json theme={null}
  {
    "type": "object",
    "properties": {
      "PCID": {
        "type": "string",
        "description": "Pink Connect ID for the authenticated connection"
      },
      "limit": {
        "type": "integer",
        "description": "Maximum number of results to return"
      },
      "offset": {
        "type": "integer",
        "description": "The offset value"
      },
      "query": {
        "type": "object",
        "description": "Search query string"
      },
      "sort": {
        "type": "array",
        "items": {
          "type": "object",
          "properties": {
            "field": {
              "type": "string",
              "description": "The field value"
            },
            "language": {
              "type": "string",
              "description": "The language value"
            },
            "order": {
              "type": "string",
              "enum": [
                "asc",
                "desc"
              ],
              "description": "The order value"
            },
            "mode": {
              "type": "string",
              "enum": [
                "min",
                "max",
                "avg",
                "sum"
              ],
              "description": "The mode value"
            },
            "fieldType": {
              "type": "string",
              "enum": [
                "boolean",
                "text",
                "ltext",
                "enum",
                "lenum",
                "number",
                "money",
                "date",
                "datetime",
                "time",
                "reference",
                "set_boolean",
                "set_text",
                "set_ltext",
                "set_enum",
                "set_lenum",
                "set_number",
                "set_money",
                "set_date",
                "set_datetime",
                "set_time",
                "set_reference"
              ],
              "description": "Field Type"
            },
            "filter": {
              "type": "object",
              "description": "The filter value"
            }
          },
          "required": [
            "field",
            "order"
          ]
        },
        "description": "Sort order for results"
      }
    },
    "required": [
      "PCID"
    ]
  }
  ```
</Expandable>

***

## commercetools\_customers\_delete\_associate\_roles\_by\_id

DELETE /associate-roles/\{ID}

**Parameters:**

| Parameter | Type      | Required | Default | Description                        |
| --------- | --------- | -------- | ------- | ---------------------------------- |
| `ID`      | string    | Yes      | —       | The id value                       |
| `version` | integer   | Yes      | —       | The version value                  |
| `expand`  | string\[] | No       | —       | Related resources to expand inline |

<Expandable title="inputSchema">
  ```json theme={null}
  {
    "type": "object",
    "properties": {
      "PCID": {
        "type": "string",
        "description": "Pink Connect ID for the authenticated connection"
      },
      "ID": {
        "type": "string",
        "description": "The id value"
      },
      "version": {
        "type": "integer",
        "description": "The version value"
      },
      "expand": {
        "type": "array",
        "items": {
          "type": "string"
        },
        "description": "Related resources to expand inline"
      }
    },
    "required": [
      "PCID",
      "ID",
      "version"
    ]
  }
  ```
</Expandable>

***

## commercetools\_customers\_delete\_associate\_roles\_by\_key

Deleting an AssociateRole generates the AssociateRoleDeleted Message. An AssociateRole can only be deleted if it is not assigned to any Associates.

**Parameters:**

| Parameter | Type      | Required | Default | Description                        |
| --------- | --------- | -------- | ------- | ---------------------------------- |
| `key`     | string    | Yes      | —       | The key value                      |
| `version` | integer   | Yes      | —       | The version value                  |
| `expand`  | string\[] | No       | —       | Related resources to expand inline |

<Expandable title="inputSchema">
  ```json theme={null}
  {
    "type": "object",
    "properties": {
      "PCID": {
        "type": "string",
        "description": "Pink Connect ID for the authenticated connection"
      },
      "key": {
        "type": "string",
        "description": "The key value"
      },
      "version": {
        "type": "integer",
        "description": "The version value"
      },
      "expand": {
        "type": "array",
        "items": {
          "type": "string"
        },
        "description": "Related resources to expand inline"
      }
    },
    "required": [
      "PCID",
      "key",
      "version"
    ]
  }
  ```
</Expandable>

***

## commercetools\_customers\_delete\_business\_units\_by\_id

DELETE /business-units/\{ID}

**Parameters:**

| Parameter | Type      | Required | Default | Description                        |
| --------- | --------- | -------- | ------- | ---------------------------------- |
| `ID`      | string    | Yes      | —       | The id value                       |
| `version` | integer   | Yes      | —       | The version value                  |
| `expand`  | string\[] | No       | —       | Related resources to expand inline |

<Expandable title="inputSchema">
  ```json theme={null}
  {
    "type": "object",
    "properties": {
      "PCID": {
        "type": "string",
        "description": "Pink Connect ID for the authenticated connection"
      },
      "ID": {
        "type": "string",
        "description": "The id value"
      },
      "version": {
        "type": "integer",
        "description": "The version value"
      },
      "expand": {
        "type": "array",
        "items": {
          "type": "string"
        },
        "description": "Related resources to expand inline"
      }
    },
    "required": [
      "PCID",
      "ID",
      "version"
    ]
  }
  ```
</Expandable>

***

## commercetools\_customers\_delete\_business\_units\_by\_key

DELETE /business-units/key=\{key}

**Parameters:**

| Parameter | Type      | Required | Default | Description                        |
| --------- | --------- | -------- | ------- | ---------------------------------- |
| `key`     | string    | Yes      | —       | The key value                      |
| `version` | integer   | Yes      | —       | The version value                  |
| `expand`  | string\[] | No       | —       | Related resources to expand inline |

<Expandable title="inputSchema">
  ```json theme={null}
  {
    "type": "object",
    "properties": {
      "PCID": {
        "type": "string",
        "description": "Pink Connect ID for the authenticated connection"
      },
      "key": {
        "type": "string",
        "description": "The key value"
      },
      "version": {
        "type": "integer",
        "description": "The version value"
      },
      "expand": {
        "type": "array",
        "items": {
          "type": "string"
        },
        "description": "Related resources to expand inline"
      }
    },
    "required": [
      "PCID",
      "key",
      "version"
    ]
  }
  ```
</Expandable>

***

## commercetools\_customers\_delete\_by\_id

Deleting a Customer produces the CustomerDeleted Message.

**Parameters:**

| Parameter     | Type      | Required | Default | Description                        |
| ------------- | --------- | -------- | ------- | ---------------------------------- |
| `ID`          | string    | Yes      | —       | The id value                       |
| `dataErasure` | boolean   | No       | —       | Data Erasure                       |
| `version`     | integer   | Yes      | —       | The version value                  |
| `expand`      | string\[] | No       | —       | Related resources to expand inline |

<Expandable title="inputSchema">
  ```json theme={null}
  {
    "type": "object",
    "properties": {
      "PCID": {
        "type": "string",
        "description": "Pink Connect ID for the authenticated connection"
      },
      "ID": {
        "type": "string",
        "description": "The id value"
      },
      "dataErasure": {
        "type": "boolean",
        "description": "Data Erasure"
      },
      "version": {
        "type": "integer",
        "description": "The version value"
      },
      "expand": {
        "type": "array",
        "items": {
          "type": "string"
        },
        "description": "Related resources to expand inline"
      }
    },
    "required": [
      "PCID",
      "ID",
      "version"
    ]
  }
  ```
</Expandable>

***

## commercetools\_customers\_delete\_by\_key

Deleting a Customer produces the CustomerDeleted Message.

**Parameters:**

| Parameter     | Type      | Required | Default | Description                        |
| ------------- | --------- | -------- | ------- | ---------------------------------- |
| `key`         | string    | Yes      | —       | The key value                      |
| `dataErasure` | boolean   | No       | —       | Data Erasure                       |
| `version`     | integer   | Yes      | —       | The version value                  |
| `expand`      | string\[] | No       | —       | Related resources to expand inline |

<Expandable title="inputSchema">
  ```json theme={null}
  {
    "type": "object",
    "properties": {
      "PCID": {
        "type": "string",
        "description": "Pink Connect ID for the authenticated connection"
      },
      "key": {
        "type": "string",
        "description": "The key value"
      },
      "dataErasure": {
        "type": "boolean",
        "description": "Data Erasure"
      },
      "version": {
        "type": "integer",
        "description": "The version value"
      },
      "expand": {
        "type": "array",
        "items": {
          "type": "string"
        },
        "description": "Related resources to expand inline"
      }
    },
    "required": [
      "PCID",
      "key",
      "version"
    ]
  }
  ```
</Expandable>

***

## commercetools\_customers\_delete\_customer\_groups\_by\_id

DELETE /customer-groups/\{ID}

**Parameters:**

| Parameter | Type      | Required | Default | Description                        |
| --------- | --------- | -------- | ------- | ---------------------------------- |
| `ID`      | string    | Yes      | —       | The id value                       |
| `version` | integer   | Yes      | —       | The version value                  |
| `expand`  | string\[] | No       | —       | Related resources to expand inline |

<Expandable title="inputSchema">
  ```json theme={null}
  {
    "type": "object",
    "properties": {
      "PCID": {
        "type": "string",
        "description": "Pink Connect ID for the authenticated connection"
      },
      "ID": {
        "type": "string",
        "description": "The id value"
      },
      "version": {
        "type": "integer",
        "description": "The version value"
      },
      "expand": {
        "type": "array",
        "items": {
          "type": "string"
        },
        "description": "Related resources to expand inline"
      }
    },
    "required": [
      "PCID",
      "ID",
      "version"
    ]
  }
  ```
</Expandable>

***

## commercetools\_customers\_delete\_customer\_groups\_by\_key

DELETE /customer-groups/key=\{key}

**Parameters:**

| Parameter | Type      | Required | Default | Description                        |
| --------- | --------- | -------- | ------- | ---------------------------------- |
| `key`     | string    | Yes      | —       | The key value                      |
| `version` | integer   | Yes      | —       | The version value                  |
| `expand`  | string\[] | No       | —       | Related resources to expand inline |

<Expandable title="inputSchema">
  ```json theme={null}
  {
    "type": "object",
    "properties": {
      "PCID": {
        "type": "string",
        "description": "Pink Connect ID for the authenticated connection"
      },
      "key": {
        "type": "string",
        "description": "The key value"
      },
      "version": {
        "type": "integer",
        "description": "The version value"
      },
      "expand": {
        "type": "array",
        "items": {
          "type": "string"
        },
        "description": "Related resources to expand inline"
      }
    },
    "required": [
      "PCID",
      "key",
      "version"
    ]
  }
  ```
</Expandable>

***

## commercetools\_customers\_get\_associate\_roles\_by\_id

GET /associate-roles/\{ID}

**Parameters:**

| Parameter | Type      | Required | Default | Description                        |
| --------- | --------- | -------- | ------- | ---------------------------------- |
| `ID`      | string    | Yes      | —       | The id value                       |
| `expand`  | string\[] | No       | —       | Related resources to expand inline |

<Expandable title="inputSchema">
  ```json theme={null}
  {
    "type": "object",
    "properties": {
      "PCID": {
        "type": "string",
        "description": "Pink Connect ID for the authenticated connection"
      },
      "ID": {
        "type": "string",
        "description": "The id value"
      },
      "expand": {
        "type": "array",
        "items": {
          "type": "string"
        },
        "description": "Related resources to expand inline"
      }
    },
    "required": [
      "PCID",
      "ID"
    ]
  }
  ```
</Expandable>

***

## commercetools\_customers\_get\_associate\_roles\_by\_key

GET /associate-roles/key=\{key}

**Parameters:**

| Parameter | Type      | Required | Default | Description                        |
| --------- | --------- | -------- | ------- | ---------------------------------- |
| `key`     | string    | Yes      | —       | The key value                      |
| `expand`  | string\[] | No       | —       | Related resources to expand inline |

<Expandable title="inputSchema">
  ```json theme={null}
  {
    "type": "object",
    "properties": {
      "PCID": {
        "type": "string",
        "description": "Pink Connect ID for the authenticated connection"
      },
      "key": {
        "type": "string",
        "description": "The key value"
      },
      "expand": {
        "type": "array",
        "items": {
          "type": "string"
        },
        "description": "Related resources to expand inline"
      }
    },
    "required": [
      "PCID",
      "key"
    ]
  }
  ```
</Expandable>

***

## commercetools\_customers\_get\_business\_units\_associates\_by\_business\_unit\_id\_and\_associate\_id

Retrieves roles and permissions of an Associate in a Business Unit.

**Parameters:**

| Parameter        | Type   | Required | Default | Description      |
| ---------------- | ------ | -------- | ------- | ---------------- |
| `businessUnitId` | string | Yes      | —       | Business Unit Id |
| `associateId`    | string | Yes      | —       | Associate Id     |

<Expandable title="inputSchema">
  ```json theme={null}
  {
    "type": "object",
    "properties": {
      "PCID": {
        "type": "string",
        "description": "Pink Connect ID for the authenticated connection"
      },
      "businessUnitId": {
        "type": "string",
        "description": "Business Unit Id"
      },
      "associateId": {
        "type": "string",
        "description": "Associate Id"
      }
    },
    "required": [
      "PCID",
      "businessUnitId",
      "associateId"
    ]
  }
  ```
</Expandable>

***

## commercetools\_customers\_get\_business\_units\_associates\_by\_key\_and\_associate\_id

Retrieves roles and permissions of an Associate in a Business Unit.

**Parameters:**

| Parameter     | Type   | Required | Default | Description   |
| ------------- | ------ | -------- | ------- | ------------- |
| `key`         | string | Yes      | —       | The key value |
| `associateId` | string | Yes      | —       | Associate Id  |

<Expandable title="inputSchema">
  ```json theme={null}
  {
    "type": "object",
    "properties": {
      "PCID": {
        "type": "string",
        "description": "Pink Connect ID for the authenticated connection"
      },
      "key": {
        "type": "string",
        "description": "The key value"
      },
      "associateId": {
        "type": "string",
        "description": "Associate Id"
      }
    },
    "required": [
      "PCID",
      "key",
      "associateId"
    ]
  }
  ```
</Expandable>

***

## commercetools\_customers\_get\_business\_units\_by\_id

GET /business-units/\{ID}

**Parameters:**

| Parameter | Type      | Required | Default | Description                        |
| --------- | --------- | -------- | ------- | ---------------------------------- |
| `ID`      | string    | Yes      | —       | The id value                       |
| `expand`  | string\[] | No       | —       | Related resources to expand inline |

<Expandable title="inputSchema">
  ```json theme={null}
  {
    "type": "object",
    "properties": {
      "PCID": {
        "type": "string",
        "description": "Pink Connect ID for the authenticated connection"
      },
      "ID": {
        "type": "string",
        "description": "The id value"
      },
      "expand": {
        "type": "array",
        "items": {
          "type": "string"
        },
        "description": "Related resources to expand inline"
      }
    },
    "required": [
      "PCID",
      "ID"
    ]
  }
  ```
</Expandable>

***

## commercetools\_customers\_get\_business\_units\_by\_key

GET /business-units/key=\{key}

**Parameters:**

| Parameter | Type      | Required | Default | Description                        |
| --------- | --------- | -------- | ------- | ---------------------------------- |
| `key`     | string    | Yes      | —       | The key value                      |
| `expand`  | string\[] | No       | —       | Related resources to expand inline |

<Expandable title="inputSchema">
  ```json theme={null}
  {
    "type": "object",
    "properties": {
      "PCID": {
        "type": "string",
        "description": "Pink Connect ID for the authenticated connection"
      },
      "key": {
        "type": "string",
        "description": "The key value"
      },
      "expand": {
        "type": "array",
        "items": {
          "type": "string"
        },
        "description": "Related resources to expand inline"
      }
    },
    "required": [
      "PCID",
      "key"
    ]
  }
  ```
</Expandable>

***

## commercetools\_customers\_get\_by\_id

GET /customers/\{ID}

**Parameters:**

| Parameter | Type      | Required | Default | Description                        |
| --------- | --------- | -------- | ------- | ---------------------------------- |
| `ID`      | string    | Yes      | —       | The id value                       |
| `expand`  | string\[] | No       | —       | Related resources to expand inline |

<Expandable title="inputSchema">
  ```json theme={null}
  {
    "type": "object",
    "properties": {
      "PCID": {
        "type": "string",
        "description": "Pink Connect ID for the authenticated connection"
      },
      "ID": {
        "type": "string",
        "description": "The id value"
      },
      "expand": {
        "type": "array",
        "items": {
          "type": "string"
        },
        "description": "Related resources to expand inline"
      }
    },
    "required": [
      "PCID",
      "ID"
    ]
  }
  ```
</Expandable>

***

## commercetools\_customers\_get\_by\_key

GET /customers/key=\{key}

**Parameters:**

| Parameter | Type      | Required | Default | Description                        |
| --------- | --------- | -------- | ------- | ---------------------------------- |
| `key`     | string    | Yes      | —       | The key value                      |
| `expand`  | string\[] | No       | —       | Related resources to expand inline |

<Expandable title="inputSchema">
  ```json theme={null}
  {
    "type": "object",
    "properties": {
      "PCID": {
        "type": "string",
        "description": "Pink Connect ID for the authenticated connection"
      },
      "key": {
        "type": "string",
        "description": "The key value"
      },
      "expand": {
        "type": "array",
        "items": {
          "type": "string"
        },
        "description": "Related resources to expand inline"
      }
    },
    "required": [
      "PCID",
      "key"
    ]
  }
  ```
</Expandable>

***

## commercetools\_customers\_get\_customer\_groups\_by\_id

GET /customer-groups/\{ID}

**Parameters:**

| Parameter | Type      | Required | Default | Description                        |
| --------- | --------- | -------- | ------- | ---------------------------------- |
| `ID`      | string    | Yes      | —       | The id value                       |
| `expand`  | string\[] | No       | —       | Related resources to expand inline |

<Expandable title="inputSchema">
  ```json theme={null}
  {
    "type": "object",
    "properties": {
      "PCID": {
        "type": "string",
        "description": "Pink Connect ID for the authenticated connection"
      },
      "ID": {
        "type": "string",
        "description": "The id value"
      },
      "expand": {
        "type": "array",
        "items": {
          "type": "string"
        },
        "description": "Related resources to expand inline"
      }
    },
    "required": [
      "PCID",
      "ID"
    ]
  }
  ```
</Expandable>

***

## commercetools\_customers\_get\_customer\_groups\_by\_key

GET /customer-groups/key=\{key}

**Parameters:**

| Parameter | Type      | Required | Default | Description                        |
| --------- | --------- | -------- | ------- | ---------------------------------- |
| `key`     | string    | Yes      | —       | The key value                      |
| `expand`  | string\[] | No       | —       | Related resources to expand inline |

<Expandable title="inputSchema">
  ```json theme={null}
  {
    "type": "object",
    "properties": {
      "PCID": {
        "type": "string",
        "description": "Pink Connect ID for the authenticated connection"
      },
      "key": {
        "type": "string",
        "description": "The key value"
      },
      "expand": {
        "type": "array",
        "items": {
          "type": "string"
        },
        "description": "Related resources to expand inline"
      }
    },
    "required": [
      "PCID",
      "key"
    ]
  }
  ```
</Expandable>

***

## commercetools\_customers\_list\_associate\_roles

GET /associate-roles

**Parameters:**

| Parameter   | Type      | Required | Default | Description                         |
| ----------- | --------- | -------- | ------- | ----------------------------------- |
| `expand`    | string\[] | No       | —       | Related resources to expand inline  |
| `sort`      | string\[] | No       | —       | Sort order for results              |
| `limit`     | integer   | No       | —       | Maximum number of results to return |
| `offset`    | integer   | No       | —       | The offset value                    |
| `withTotal` | boolean   | No       | —       | With Total                          |
| `where`     | string\[] | No       | —       | The where value                     |

<Expandable title="inputSchema">
  ```json theme={null}
  {
    "type": "object",
    "properties": {
      "PCID": {
        "type": "string",
        "description": "Pink Connect ID for the authenticated connection"
      },
      "expand": {
        "type": "array",
        "items": {
          "type": "string"
        },
        "description": "Related resources to expand inline"
      },
      "sort": {
        "type": "array",
        "items": {
          "type": "string"
        },
        "description": "Sort order for results"
      },
      "limit": {
        "type": "integer",
        "description": "Maximum number of results to return"
      },
      "offset": {
        "type": "integer",
        "description": "The offset value"
      },
      "withTotal": {
        "type": "boolean",
        "description": "With Total"
      },
      "where": {
        "type": "array",
        "items": {
          "type": "string"
        },
        "description": "The where value"
      }
    },
    "required": [
      "PCID"
    ]
  }
  ```
</Expandable>

***

## commercetools\_customers\_list\_business\_units

GET /business-units

**Parameters:**

| Parameter   | Type      | Required | Default | Description                         |
| ----------- | --------- | -------- | ------- | ----------------------------------- |
| `expand`    | string\[] | No       | —       | Related resources to expand inline  |
| `sort`      | string\[] | No       | —       | Sort order for results              |
| `limit`     | integer   | No       | —       | Maximum number of results to return |
| `offset`    | integer   | No       | —       | The offset value                    |
| `withTotal` | boolean   | No       | —       | With Total                          |
| `where`     | string\[] | No       | —       | The where value                     |

<Expandable title="inputSchema">
  ```json theme={null}
  {
    "type": "object",
    "properties": {
      "PCID": {
        "type": "string",
        "description": "Pink Connect ID for the authenticated connection"
      },
      "expand": {
        "type": "array",
        "items": {
          "type": "string"
        },
        "description": "Related resources to expand inline"
      },
      "sort": {
        "type": "array",
        "items": {
          "type": "string"
        },
        "description": "Sort order for results"
      },
      "limit": {
        "type": "integer",
        "description": "Maximum number of results to return"
      },
      "offset": {
        "type": "integer",
        "description": "The offset value"
      },
      "withTotal": {
        "type": "boolean",
        "description": "With Total"
      },
      "where": {
        "type": "array",
        "items": {
          "type": "string"
        },
        "description": "The where value"
      }
    },
    "required": [
      "PCID"
    ]
  }
  ```
</Expandable>

***

## commercetools\_customers\_list\_business\_units\_search\_indexing\_status

Returns the indexing status of the Business Unit Search for a Project.

<Expandable title="inputSchema">
  ```json theme={null}
  {
    "type": "object",
    "properties": {
      "PCID": {
        "type": "string",
        "description": "Pink Connect ID for the authenticated connection"
      }
    },
    "required": [
      "PCID"
    ]
  }
  ```
</Expandable>

***

## commercetools\_customers\_list\_customer\_groups

GET /customer-groups

**Parameters:**

| Parameter   | Type      | Required | Default | Description                         |
| ----------- | --------- | -------- | ------- | ----------------------------------- |
| `where`     | string\[] | No       | —       | The where value                     |
| `expand`    | string\[] | No       | —       | Related resources to expand inline  |
| `sort`      | string\[] | No       | —       | Sort order for results              |
| `limit`     | integer   | No       | —       | Maximum number of results to return |
| `offset`    | integer   | No       | —       | The offset value                    |
| `withTotal` | boolean   | No       | —       | With Total                          |

<Expandable title="inputSchema">
  ```json theme={null}
  {
    "type": "object",
    "properties": {
      "PCID": {
        "type": "string",
        "description": "Pink Connect ID for the authenticated connection"
      },
      "where": {
        "type": "array",
        "items": {
          "type": "string"
        },
        "description": "The where value"
      },
      "expand": {
        "type": "array",
        "items": {
          "type": "string"
        },
        "description": "Related resources to expand inline"
      },
      "sort": {
        "type": "array",
        "items": {
          "type": "string"
        },
        "description": "Sort order for results"
      },
      "limit": {
        "type": "integer",
        "description": "Maximum number of results to return"
      },
      "offset": {
        "type": "integer",
        "description": "The offset value"
      },
      "withTotal": {
        "type": "boolean",
        "description": "With Total"
      }
    },
    "required": [
      "PCID"
    ]
  }
  ```
</Expandable>

***

## commercetools\_customers\_list\_customers

GET /customers

**Parameters:**

| Parameter   | Type      | Required | Default | Description                         |
| ----------- | --------- | -------- | ------- | ----------------------------------- |
| `expand`    | string\[] | No       | —       | Related resources to expand inline  |
| `sort`      | string\[] | No       | —       | Sort order for results              |
| `limit`     | integer   | No       | —       | Maximum number of results to return |
| `offset`    | integer   | No       | —       | The offset value                    |
| `withTotal` | boolean   | No       | —       | With Total                          |
| `where`     | string\[] | No       | —       | The where value                     |

<Expandable title="inputSchema">
  ```json theme={null}
  {
    "type": "object",
    "properties": {
      "PCID": {
        "type": "string",
        "description": "Pink Connect ID for the authenticated connection"
      },
      "expand": {
        "type": "array",
        "items": {
          "type": "string"
        },
        "description": "Related resources to expand inline"
      },
      "sort": {
        "type": "array",
        "items": {
          "type": "string"
        },
        "description": "Sort order for results"
      },
      "limit": {
        "type": "integer",
        "description": "Maximum number of results to return"
      },
      "offset": {
        "type": "integer",
        "description": "The offset value"
      },
      "withTotal": {
        "type": "boolean",
        "description": "With Total"
      },
      "where": {
        "type": "array",
        "items": {
          "type": "string"
        },
[...]
